/***************************************************************************
                          dlgxmlattribute.cpp  -  description
                             -------------------
    begin                : Fre Jul 12 2002
    copyright            : (C) 2002 by The KXMLEditor Team
    email                : lvanek@eanet.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgxmlattribute.h"

#include <klineedit.h>
#include <kdebug.h>

#include <qpushbutton.h>

DlgXMLAttribute::DlgXMLAttribute( QWidget * pParent, const char * pszName, bool fModal, WFlags fl )
	: DlgXMLAttributeBase( pParent, pszName, fModal, fl )
{
	connect( m_pEditQName, SIGNAL(textChanged(const QString &)), this, SLOT(slotDataChanged()) );
	connect( m_pEditValue, SIGNAL(textChanged(const QString &)), this, SLOT(slotDataChanged()) );
}

void DlgXMLAttribute::clearDialog()
{
	m_pEditNamespace->clear();
	m_pEditQName->clear();
	m_pEditValue->clear();
}

int DlgXMLAttribute::exec( QDomElement & domElement )
{
	if ( domElement.isNull() )
	{
		kdError() << "DlgXMLAttribute::exec the given XML element object is empty." << endl;
		return Rejected;
	}

	clearDialog();

	int iReturn = exec();
	if ( iReturn == Accepted )
	{
		if ( m_pEditNamespace->text().isEmpty() )
			domElement.setAttribute( m_pEditQName->text(), m_pEditValue->text() );
		else
			domElement.setAttributeNS( m_pEditNamespace->text(), m_pEditQName->text(), m_pEditValue->text() );
	}

	return iReturn;
}

int DlgXMLAttribute::exec()
{
	m_pBtnOK->setEnabled(false);
		
	m_pEditQName->setFocus();
	m_pBtnOK->setDefault(true);

	return DlgXMLAttributeBase::exec();
}

void DlgXMLAttribute::slotDataChanged()
{
	if ( (m_pEditQName->text().isEmpty()) || (m_pEditValue->text().isEmpty()) )
		m_pBtnOK->setEnabled(false);
	else
		m_pBtnOK->setEnabled(true);
}
